GDCM: gdcm::JPEGLSCodec Class Reference

GDCM 3.2.6

Public Member Functions | Protected Member Functions | Friends | List of all members
gdcm::JPEGLSCodec Class Reference

JPEG-LS. More...

`#include <gdcmJPEGLSCodec.h>`

Inheritance diagram for gdcm::JPEGLSCodec:
[legend]
Collaboration diagram for gdcm::JPEGLSCodec:
[legend]

## Public Member Functions
| JPEGLSCodec ()
| ~JPEGLSCodec () override
bool | CanCode (TransferSyntax const &ts) const override
| Return whether this coder support this transfer syntax (can code it).
bool | CanDecode (TransferSyntax const &ts) const override
| Return whether this decoder support this transfer syntax (can decode it).
ImageCodec * | Clone () const override
bool | Code (DataElement const &in, DataElement &out) override
| Code.
bool | Decode (DataElement const &in, char *outBuffer, size_t inBufferLength, uint32_t inXMin, uint32_t inXMax, uint32_t inYMin, uint32_t inYMax, uint32_t inZMin, uint32_t inZMax)
bool | Decode (DataElement const &is, DataElement &os) override
| Decode.
unsigned long | GetBufferLength () const
bool | GetHeaderInfo (std::istream &is, TransferSyntax &ts) override
bool | GetLossless () const
void | SetBufferLength (unsigned long l)
void | SetLossless (bool l)
void | SetLossyError (int error)
| [0-3] generally
Public Member Functions inherited from gdcm::ImageCodec
| ImageCodec ()
| ~ImageCodec () override
bool | CleanupUnusedBits (char *data, size_t datalen)
const unsigned int * | GetDimensions () const
bool | GetLossyFlag () const
const LookupTable & | GetLUT () const
bool | GetNeedByteSwap () const
unsigned int | GetNumberOfDimensions () const
const PhotometricInterpretation & | GetPhotometricInterpretation () const
PixelFormat & | GetPixelFormat ()
const PixelFormat & | GetPixelFormat () const
unsigned int | GetPlanarConfiguration () const
bool | IsLossy () const
void | SetDimensions (const std::vector< unsigned int > &d)
void | SetDimensions (const unsigned int d[3])
void | SetLossyFlag (bool l)
void | SetLUT (LookupTable const &lut)
void | SetNeedByteSwap (bool b)
void | SetNeedOverlayCleanup (bool b)
void | SetNumberOfDimensions (unsigned int dim)
void | SetPhotometricInterpretation (PhotometricInterpretation const &pi)
virtual void | SetPixelFormat (PixelFormat const &pf)
void | SetPlanarConfiguration (unsigned int pc)
Public Member Functions inherited from gdcm::Coder
virtual | ~Coder ()=default
Public Member Functions inherited from gdcm::Decoder
virtual | ~Decoder ()=default

## Protected Member Functions
bool | AppendFrameEncode (std::ostream &out, const char *data, size_t datalen) override
bool | AppendRowEncode (std::ostream &out, const char *data, size_t datalen) override
bool | DecodeExtent (char *buffer, unsigned int xmin, unsigned int xmax, unsigned int ymin, unsigned int ymax, unsigned int zmin, unsigned int zmax, std::istream &is)
bool | IsFrameEncoder () override
bool | IsRowEncoder () override
bool | StartEncode (std::ostream &) override
bool | StopEncode (std::ostream &) override
Protected Member Functions inherited from gdcm::ImageCodec
bool | DecodeByStreams (std::istream &is_, std::ostream &os) override
bool | DoByteSwap (std::istream &is_, std::ostream &os)
bool | DoInvertMonochrome (std::istream &is_, std::ostream &os)
bool | DoOverlayCleanup (std::istream &is_, std::ostream &os)
bool | DoPaddedCompositePixelCode (std::istream &is_, std::ostream &os)
bool | DoPlanarConfiguration (std::istream &is_, std::ostream &os)
bool | DoSimpleCopy (std::istream &is_, std::ostream &os)
bool | DoYBR (std::istream &is_, std::ostream &os)
bool | DoYBRFull422 (std::istream &is_, std::ostream &os)
virtual bool | IsValid (PhotometricInterpretation const &pi)
Protected Member Functions inherited from gdcm::Coder
virtual bool | InternalCode (const char *bv, unsigned long len, std::ostream &os)

## Friends
class | ImageRegionReader

## Additional Inherited Members
Protected Types inherited from gdcm::ImageCodec
typedef SmartPointer< LookupTable > | LUTPtr
Protected Attributes inherited from gdcm::ImageCodec
unsigned int | Dimensions [3]
bool | LossyFlag
LUTPtr | LUT
bool | NeedByteSwap
bool | NeedOverlayCleanup
unsigned int | NumberOfDimensions
PixelFormat | PF
PhotometricInterpretation | PI
unsigned int | PlanarConfiguration
bool | RequestPaddedCompositePixelCode
bool | RequestPlanarConfiguration

## Detailed Description

JPEG-LS.

Note
  codec that implement the JPEG-LS compression this is an implementation of ImageCodec for JPEG-LS

It uses the CharLS JPEG-LS implementation https://github.com/team-charls/charls

## Constructor & Destructor Documentation

## ◆ JPEGLSCodec()

gdcm::JPEGLSCodec::JPEGLSCodec | ( |  | ) |

## ◆ ~JPEGLSCodec()

gdcm::JPEGLSCodec::~JPEGLSCodec | ( |  | ) |
| override

## Member Function Documentation

## ◆ AppendFrameEncode()

bool gdcm::JPEGLSCodec::AppendFrameEncode | ( | std::ostream & | out,
|  | const char * | data,
|  | size_t | datalen )
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ AppendRowEncode()

bool gdcm::JPEGLSCodec::AppendRowEncode | ( | std::ostream & | out,
|  | const char * | data,
|  | size_t | datalen )
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ CanCode()

bool gdcm::JPEGLSCodec::CanCode | ( | TransferSyntax const & |  | ) | const
| overridevirtual

Return whether this coder support this transfer syntax (can code it).

Reimplemented from gdcm::ImageCodec.

## ◆ CanDecode()

bool gdcm::JPEGLSCodec::CanDecode | ( | TransferSyntax const & |  | ) | const
| overridevirtual

Return whether this decoder support this transfer syntax (can decode it).

Reimplemented from gdcm::ImageCodec.

## ◆ Clone()

ImageCodec * gdcm::JPEGLSCodec::Clone | ( |  | ) | const
| overridevirtual

Implements gdcm::ImageCodec.

References gdcm::ImageCodec::ImageCodec().

## ◆ Code()

bool gdcm::JPEGLSCodec::Code | ( | DataElement const & | in_,
|  | DataElement & | out_ )
| overridevirtual

Code.

Reimplemented from gdcm::Coder.

## ◆ Decode() [1/2]

bool gdcm::JPEGLSCodec::Decode | ( | DataElement const & | in,
|  | char * | outBuffer,
|  | size_t | inBufferLength,
|  | uint32_t | inXMin,
|  | uint32_t | inXMax,
|  | uint32_t | inYMin,
|  | uint32_t | inYMax,
|  | uint32_t | inZMin,
|  | uint32_t | inZMax )

## ◆ Decode() [2/2]

bool gdcm::JPEGLSCodec::Decode | ( | DataElement const & | ,
|  | DataElement & | )
| overridevirtual

Decode.

Reimplemented from gdcm::ImageCodec.

## ◆ DecodeExtent()

bool gdcm::JPEGLSCodec::DecodeExtent | ( | char * | buffer,
|  | unsigned int | xmin,
|  | unsigned int | xmax,
|  | unsigned int | ymin,
|  | unsigned int | ymax,
|  | unsigned int | zmin,
|  | unsigned int | zmax,
|  | std::istream & | is )
| protected

## ◆ GetBufferLength()

unsigned long gdcm::JPEGLSCodec::GetBufferLength | ( |  | ) | const
| inline

## ◆ GetHeaderInfo()

bool gdcm::JPEGLSCodec::GetHeaderInfo | ( | std::istream & | is,
|  | TransferSyntax & | ts )
| overridevirtual

Reimplemented from gdcm::ImageCodec.

## ◆ GetLossless()

bool gdcm::JPEGLSCodec::GetLossless | ( |  | ) | const

## ◆ IsFrameEncoder()

bool gdcm::JPEGLSCodec::IsFrameEncoder | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ IsRowEncoder()

bool gdcm::JPEGLSCodec::IsRowEncoder | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ SetBufferLength()

void gdcm::JPEGLSCodec::SetBufferLength | ( | unsigned long | l | ) |
| inline

## ◆ SetLossless()

void gdcm::JPEGLSCodec::SetLossless | ( | bool | l | ) |

## ◆ SetLossyError()

void gdcm::JPEGLSCodec::SetLossyError | ( | int | error | ) |

[0-3] generally

## ◆ StartEncode()

bool gdcm::JPEGLSCodec::StartEncode | ( | std::ostream & |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ StopEncode()

bool gdcm::JPEGLSCodec::StopEncode | ( | std::ostream & |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## Friends And Related Symbol Documentation

## ◆ ImageRegionReader

friend class ImageRegionReader
| friend

References ImageRegionReader.

Referenced by ImageRegionReader.

The documentation for this class was generated from the following file:

- gdcmJPEGLSCodec.h